package com.tarena.aircraft;

import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.List;

import org.loon.framework.javase.game.GameDeploy;
import org.loon.framework.javase.game.core.graphics.LImage;
import org.loon.framework.javase.game.core.graphics.Screen;
import org.loon.framework.javase.game.core.graphics.device.LGraphics;
import org.loon.framework.javase.game.core.timer.LTimer;
import org.loon.framework.javase.game.core.timer.LTimerContext;

public class GameScreen extends Screen {
	
	// ҷɻƶٶ
	private int player_speed = 5;
	
	// Ұĸ
	private boolean to_up = false;
	private boolean to_down = false;
	private boolean to_left = false;
	private boolean to_right = false;
	
	// ҷɻ
	private AircraftSprite player;

	// л
	private List<AircraftSprite> foeList = new ArrayList<AircraftSprite>();

	// ӵ
	private List<AircraftSprite> bulletList = new ArrayList<AircraftSprite>();

	// лʱڿƵлֵƵʣ800룩
	private LTimer foeTimer = new LTimer(800);

	// ӵʱڿӵֵƵʣ300룩
	private LTimer bulletTimer = new LTimer(200);

	// ƵлӵеƵ
	private LTimer timer = new LTimer(20);

	// ٶʱ
	private LTimer destroyTimer = new LTimer(150);

	// ҷ
	private int score = 0;

	private GameDeploy deploy;

	public GameScreen(GameDeploy deploy) {
		this.deploy = deploy;
	}

	@Override
	public void onLoaded() {
		super.onLoad();
		
		//  ʼ
		initBackGround();
		
		//  ʼҵķɻ
		initPlayer();
		
	}

	/**
	 *  ʼ
	 */
	private void initBackGround(){
		// ر
		LImage background = new LImage("assets/bg_480_720.png");
		this.setBackground(background);
	}
	/**
	 *  ʼҵķɻ
	 */
	private void initPlayer(){
		// ҷɻ
		player = new AircraftSprite("assets/player_aircraft.png",
				"assets/player_aircraft_destroy.png", 110, 120);
		add(player);
		player.setLocation(200, 500);
	}
	
	
	
	@Override
	public void alter(LTimerContext timerCtx) {
		/**
		 * ÿ֡ˢʱȿҵķɻǷʼϣʼòſʼϷ߼
		 */
		if(player == null){
			return;
		}
		if (timer.action(timerCtx)) {
			// ƶҵķɻ
			movePlayer();
			
			// ƶл
			moveEnemy();
			
			// ƶӵ
			moveBullet();

			// ӵǷ򵽵л
			checkHitEnemy();

			// ɾɾǵӵ
			removeBullet();

			// жϵǷײɻ
			checkHitPlayer();
		}

		// л
		if (foeTimer.action(timerCtx)) {
			createEnemy();
		}
		
		// ӵ,ÿδ
		if (bulletTimer.action(timerCtx)) {
			createBullet();
		}
		
		// ʾٶ
		if (destroyTimer.action(timerCtx)) {
			playDestoryEnemy();			
			playDestoryPlayer();
		}

	}

	
	/**
	 * ƶҵķɻ
	 */
	private void movePlayer(){
		if(player != null){
			if (to_up&&player.getY() > 0) {
				player.move_up(player_speed);
			}
			if (to_down&&player.getY() < (getHeight() - player.getHeight())) {
				player.move_down(player_speed);
			}
			if (to_right&&player.getX() < (getWidth() - player.getWidth())) {
				player.move_right(player_speed);
			}
			if (to_left&&player.getX() > 0) {
				player.move_left(player_speed);
			}
		}
	}
	
	/**
	 *  ƶл
	 */
	private void moveEnemy(){
		for (int i = foeList.size() - 1; i >= 0; i--) {
			foeList.get(i).move_down(4);
			if (foeList.get(i).getY() > getHeight()) {
				// ӳɾ
				remove(foeList.get(i));
				// Ӽɾ
				foeList.remove(i);
			}
		}
	}
	
	/**
	 *  ƶӵ
	 */
	private void moveBullet(){
		for (int i = 0; i < bulletList.size(); i++) {
			bulletList.get(i).move_up(10);
			if (bulletList.get(i).getY() < 0) {
				bulletList.get(i).setDestroy(true);
			}
		}
	}
	
	/**
	 *  ӵǷлел
	 */
	private void checkHitEnemy(){
		for (AircraftSprite foe : foeList) {
			for (AircraftSprite bullet : bulletList) {
				boolean isCollision = bullet.checkCollision(foe);
				if (isCollision) {
					// лӵɾ
					foe.setDestroy(true);
					foe.setShowDestroyAnimation(true);
					bullet.setDestroy(true);
					score += 100;
				}
			}
		}
	}
	
	/**
	 *   ɾӵ
	 */
	private void removeBullet(){
		for (int i = bulletList.size() - 1; i >= 0; i--) {
			if (bulletList.get(i).isDestroy()) {
				// ӳɾ
				remove(bulletList.get(i));
				// Ӽɾ
				bulletList.remove(i);
			}

		}
	}
	
	/**
	 * л
	 * @param timerCtx
	 */
	private void createEnemy(){
		// һ
		System.out.println("һ");
		// ƶʾͼƬٵĶͼƬ
		AircraftSprite foeAircraft = new AircraftSprite(
				"assets/foe_aircraft.png",
				"assets/foe_aircraft_destroy.png", 69, 94);
		foeAircraft.setLocation(Math.random()
				* (getWidth() - foeAircraft.getWidth()), -94);
		// 뼯
		foeList.add(foeAircraft);
		// 볡
		add(foeAircraft);
	}
	
	/**
	 * ӵ
	 * @param timerCtx
	 */
	private void createBullet(){
		AircraftSprite leftBullet = new AircraftSprite(
				"assets/bullet.png");
		AircraftSprite rightBullet = new AircraftSprite(
				"assets/bullet.png");
		leftBullet.setLocation(player.getX() + 23, player.getY() + 25);
		rightBullet.setLocation(player.getX() + 80, player.getY() + 25);
		add(leftBullet);
		add(rightBullet);
		bulletList.add(leftBullet);
		bulletList.add(rightBullet);
	}
	
	/**
	 *   жϵǷ
	 */
	private void checkHitPlayer(){
		for (AircraftSprite foe : foeList) {
			boolean isCollision = foe.checkCollision(player);
			if (isCollision) {
				player.setDestroy(true);
				player.setShowDestroyAnimation(true);
				break;
			}

		}
	}
	
	/**
	 *   ʾٵл
	 */
	private void playDestoryEnemy(){
		for (int i = foeList.size() - 1; i >= 0; i--) {
			AircraftSprite foe = foeList.get(i);
			if (foe.isDestroy() && foe.isShowDestroyAnimation()) {
				boolean isRemove = foe.showDestroyFrame();
				if (isRemove) {
					remove(foe);
					foeList.remove(i);
				}
			}
		}
	}
	
	/**
	 *   ʾҷɻĶ
	 */
	private void playDestoryPlayer(){
		if (player != null && player.isDestroy()
				&& player.isShowDestroyAnimation()) {
			boolean b = player.showDestroyFrame();
			if (b) {
				timer.stop();
				foeTimer.stop();
				bulletTimer.stop();
				remove(player);
				player = null;
				deploy.setScreen(new EndScreen(deploy, score));
				return;
			}
		}
	}
	
	@Override
	public void onKeyUp(LKey e) {
		// ֹplayerûмʱû
		if (player != null) {
			// ȡļֵ
			int keyCode = e.getKeyCode();
			switch (keyCode) {
			case KeyEvent.VK_UP:
				to_up = false;
				break;
			case KeyEvent.VK_DOWN:
				to_down = false;
				break;
			case KeyEvent.VK_RIGHT:
				to_right = false;
				break;
			case KeyEvent.VK_LEFT:
				to_left = false;
			}
		}
	}
	@Override
	public void onKeyDown(LKey e) {
		super.onKeyDown(e);
		// ֹplayerûмʱû
		if (player != null) {
			// ȡļֵ
			int keyCode = e.getKeyCode();
			switch (keyCode) {
			case KeyEvent.VK_UP:
				to_up = true;
				to_down = false;
				break;
			case KeyEvent.VK_DOWN:
				to_down = true;
				to_up = false;
				break;
			case KeyEvent.VK_RIGHT:
				to_right = true;
				to_left = false;
				break;
			case KeyEvent.VK_LEFT:
				to_left = true;
				to_right = false;
			}
		}
	}
	
	@Override
	public void draw(LGraphics lg) {
		// TODO Auto-generated method stub

	}
	
	@Override
	public void onTouchMove(LTouch e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onTouchUp(LTouch e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onTouchDown(LTouch e) {
		// TODO Auto-generated method stubF
	}

}
